#import "SimpleOpenGLView.h"

#import <OpenGL/gl.h>
#import <OpenGL/glu.h>

@implementation SimpleOpenGLView

//	This emit the correct glColor3f for a given NSColor (we first need to convert it to a RGB color)
//	There could be alternate, less portable, more efficient designs
- (void)emitGlColor:(NSColor *)aColor
{
    NSColor *theRGBColor = [aColor colorUsingColorSpaceName:NSDeviceRGBColorSpace];
    glColor3f( [theRGBColor redComponent], [theRGBColor greenComponent], [theRGBColor blueComponent] );
}

//	In drawRect: we e,it opengl code
- (void)drawRect:(NSRect)aRect
{
        //	First, we clear the view

        //	 This is not necessary. Looks like it is done by default
    glViewport( 0,0,NSWidth([self bounds]),NSHeight([self bounds]) );
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    glClearColor( 0,0,0,0 );
    glClear( GL_COLOR_BUFFER_BIT );


        //	The we set a coordinate system, and a point of view
    gluPerspective( 60,1,1.5,20 );
    glMatrixMode( GL_MODELVIEW );

    glLoadIdentity();
    gluLookAt( 0,0,5,0,0,0,0,1,0 );

        //	We rotate depeding on the status of the sliders
    glRotatef( [itsRotateXSlider floatValue],1,0,0 );
    glRotatef( [itsRotateYSlider floatValue],0,1,0 );
    glRotatef( [itsRotateZSlider floatValue],0,0,1 );

        //	We scale depending of the zoom slider
    glScalef( [itsZoomSlider floatValue], [itsZoomSlider floatValue], [itsZoomSlider floatValue] );

        //	We emit a quad with colored vertexes
    glBegin( GL_QUADS );
        [self emitGlColor:[itsColorWell0 color]];
        glVertex2f( -1, -1 );
        [self emitGlColor:[itsColorWell1 color]];
        glVertex2f( 1, -1 );
        [self emitGlColor:[itsColorWell2 color]];
        glVertex2f( 1, 1 );
        [self emitGlColor:[itsColorWell3 color]];
        glVertex2f( -1, 1 );
    glEnd();

        //	We flush gl code down the OpenGL pipeline
    glFlush();
}

//	We connected this as the action of every interface control
- (IBAction)interfaceChanged:sender
{	[self display];
}

@end
